<template>
  <b-container>
    <div class="background_bloc" />
    <h1 class="title">
      Paramètres du compte
    </h1>
  </b-container>

  <b-container>
    <h2>Informations générales</h2>
    <b-form>
      <div class="d-flex align-items-end mb-4">
        <img 
          v-if="store.user.contentUrl != '' && store.user.contentUrl != 'undefined'"
          :src="url + store.user.contentUrl"
          class="vendeur__img m-2"
        >
        <!-- no img -->
        <img 
          v-else
          :src="require('@/assets/images/noimguser.png')"
          alt=""
          class="vendeur__img"
        >
        <input
          id="avatar"
          type="file"
          name="avatar"
          accept="image/png, image/jpeg"
          @change="onFileUpload($event)"
        >
        <button
          class="submit btn-cta"
          type="submit"
          @click.prevent="changeAvatar($event)"
        >
          Enregistrer
        </button>
      </div>
    </b-form>
    <b-form>
      <div class="d-flex">
        <b-form-group class="w-100">
          <label>Nom</label>
          <b-form-input
            v-model="nom"
            type="text"
          />
        </b-form-group>
        <b-form-group class="w-100">
          <label>Prénom</label>
          <b-form-input
            v-model="prenom"
            type="text"
          />
        </b-form-group>
      </div>

      <b-form-group>
        <label for="feedback-pseudo">Pseudo</label>
        <b-form-input
          v-model="pseudo"
          type="text"
        />
      </b-form-group>

      <b-form-group>
        <label>Email</label>
        <b-form-input
          v-model="email"
          type="email"
        />
      </b-form-group>
      <b-form-group>
        <label for="feedback-password">Mot de passe</label>
        <b-form-input
          v-model="password"
          type="password"
        />
      </b-form-group>

      <div class="d-flex">
        <b-form-group class="w-100">
          <label>Code Postal</label>  
          <b-form-input
            v-model="code_postal"
            type="number"
          />
        </b-form-group>
        <b-form-group class="w-100">
          <label>Ville</label>  
          <b-form-input
            v-model="ville"
            type="text"
          />    
        </b-form-group>
      </div>
      <b-form-group>
        <label>Adresse</label>  
        <b-form-input
          v-model="adresse"
          type="text"
        />
      </b-form-group>

      <div>
        <input
          v-model="terms"
          type="checkbox"
          required
        >
        <label>Je ne suis pas un robot (recapcha)</label>
      </div>

      <div class="button d-flex justify-content-end">
        <button
          class="submit btn-cta"
          type="submit"
          @click.prevent="updateUser()"
        >
          Enregistrer
        </button>
      </div>
    </b-form>
  </b-container>
  <b-container>
    <h2>Informations vendeur</h2>
    <button
      v-if="store.user.vendeur == false"
      class="btn-cta"
      @click.prevent="showForm()"
    >
      Devenir vendeur
    </button>
    <button
      v-else
      class="btn-cta"
      @click.prevent="deleteSeller()"
    >
      Ne plus être vendeur
    </button>
    <b-form v-if="showVendeur == true || store.user.vendeur == true">
      <div>
        <input
          v-model="profil"
          type="checkbox"
          value="true"
          unchecked-value="false"
        >  
        <label>Profil visible par tous</label>
      </div>    
      <b-form-textarea
        id="textarea-small"
        v-model="description"
        size="sm"
        placeholder="Description"
      />
      <div class="button d-flex justify-content-end">
        <button
          v-if="seller == false"
          class="add submit btn-cta"
          type="submit"
          @click.prevent="addSeller($event)"
        >
          Enregistrer
        </button>
        <button
          v-else
          class="update submit btn-cta"
          type="submit"
          @click.prevent="updateSeller($event)"
        >
          Enregistrer
        </button>
      </div>
    </b-form>
  </b-container>
  <Modal
    ref="modalMsg"
    :message="message"
    :choix="false"
  />
</template>
<script>
import { defineComponent } from 'vue';
import { useStore } from '@/store/store'
import axios from 'axios';
import Modal from '@/components/Modal.vue';



export default defineComponent({

    components: {
      Modal
    },

    data() {
        const store = useStore();

        return {
            nom: store.user.nom,
            prenom: store.user.prenom,
            pseudo: store.user.pseudo,
            email: store.user.email,
            code_postal: store.user.codePostal,
            ville: store.user.ville,
            adresse: store.user.adresse,
            url: process.env.VUE_APP_URL,
            store,
            showVendeur: false,
            description: '',
            // par défaut profil private
            profil: false,
            seller: false,
            idSeller: '',
            message: '',
            FILE: ''
        }
    },

    mounted() {
        //on vérifie si le user est connecté, sinon redir page accueil
        let token = this.store.token;
        if(token == ''){
            this.$router.push('/');
        };
        axios.get(this.url + "/api/info_vendeurs/getbyid/" + this.store.user.id)
        .then(res => {
            if(res.data['hydra:member'].length > 0){
                this.description = res.data['hydra:member'][0].description;
                this.profil = res.data['hydra:member'][0].profilPublic;
                this.seller = true;
                this.idSeller = res.data['hydra:member'][0].id
            };
        })
        .catch(err => {
            console.log(err)
        })
    },

    methods: {
        
        onFileUpload(event) {
            this.FILE = event.target.files[0]
        },
        
        changeAvatar() {

            axios.post(this.url + "/api/utilisateurs/avatar", {
                "utilisateur_id": this.store.user.id,
                "file": this.FILE,
            },
            {
                headers: {
                    "Content-Type": "multipart/form-data"
                }
            })
            .then(response => {
                this.store.fetchUser();

            })
            .catch(err => {
                this.error =  err.response.data['hydra:description'];
                console.log(err);
            })  
        },
        
        showForm() {
            if(this.showVendeur == false){
                this.showVendeur = true;
            } else {
                this.showVendeur = false;
            }
        },
        
        addSeller() {
            // on ajoute les données du vendeur
            axios.post(this.url + "/api/info_vendeurs", {
                "utilisateur": "api/utilisateurs/" + this.store.user.id ,
                "profilPublic": this.profil,
                "description": this.description,
            })
            .then( res => {
                this.idSeller = res.data.id;
                axios.put(this.url + "/api/utilisateurs/" + this.store.user.id, {
                    "vendeur": true,
                })
                .then(response => {
                    this.message = 'Vous êtes désormais veudeur·euse !'
                    this.$refs.modalMsg.show = true
                    this.seller = true
                    store.fetchUser();
                })  
                .catch(err => {
                    console.log(err);
                }) 
            })         
            .catch(err => {
                console.log(err);
            })

            this.store.fetchUser();
        },

        updateSeller() {
            axios.patch(this.url + "/api/info_vendeurs/" + this.idSeller, {
                "utilisateur": "api/utilisateurs/" + this.store.user.id,
                "profilPublic": true,
                "description": this.description
            },
            {
                headers: {
                    'Content-Type': 'application/merge-patch+json'
                }
            })
            .then(response => {
                    axios.patch(this.url + "/api/utilisateurs/" + this.store.user.id, {
                    "vendeur": true,
                },
                {
                    headers: {
                        'Content-Type': 'application/merge-patch+json'
                    }
                })
                .then(response => {
                    this.message = 'Vos informations vendeur·euse ont été modifiées'
                    this.$refs.modalMsg.show = true;
                })    
                .catch(err => {
                    console.log(err);
                })
 
            })    
            .catch(err => {
                console.log(err);
            })

            this.store.fetchUser();

        },

        deleteSeller() {
            axios.get(this.url + "/api/info_vendeurs/delete/" + this.idSeller)
            .then(
                axios.put(this.url + "/api/utilisateurs/" + this.store.user.id, {
                    "vendeur": false,
                })
                .then(response => {
                    this.store.fetchUser();
                })  
                .catch(err => {
                    console.log(err);
                }) 
            )         
            .then(response => {
                this.message = 'Vous n\'êtes désormais plus veudeur·euse'
                this.$refs.modalMsg.show = true;
                this.seller = false;
            })
            .catch(err => {
                console.log(err);
            })

            this.store.fetchUser();

        },

        updateUser() {
            axios.put(this.url + "/api/utilisateurs/" + this.store.user.id, {
                "nom": this.nom,
                "prenom": this.prenom,
                "pseudo": this.pseudo,
                "email": this.email,
                "password": this.password,
                "codePostal": this.code_postal,
                "ville": this.ville,
                "adresse": this.adresse,
            })
            .then(response => {
                console.log(response.data);
            })    
            .catch(err => {
                // this.message = err.response.data['hydra:description'];
                // this.$refs.modalMsg.show = true;
                console.log(err);
            })
        },

    }
})
</script>
